BigTree CMS 4.0
===============
<http://www.bigtreecms.org/>

Licensing
---------
BigTree CMS is publicly licensed under the [GNU Lesser General Public License](http://www.gnu.org/copyleft/lesser.html).
If you would like to use BigTree under a different license, please [contact us](mailto:info@fastspot.com).

Contributing
------------
We would love to have the community work with us on BigTree.  Guidelines are currently being created for how community contributions will be worked back into the project. For more information, please contact <contribute@bigtreecms.org>.  If you would like to begin developing the BigTree core, follow the process below:

1. Fork it.
2. Create a branch (`git checkout -b 4.0_toms_branch`)
3. Commit your changes (`git commit -am "Fixed My Broken Foot"`)
4. Push to the branch (`git push origin 4.0_toms_branch`)
5. Create an [Issue][1] with a link to your branch

Changelog
---------

### 4.0.4 Release
- FIXED: BigTreeadmin::getPageAccessLevelByUser only working for the logged in user's permissions and made it more efficient.
- FIXED: Missing focus highlighting on installer fields
- FIXED: An issue that would cause user creation to fail in PHP 5.2
- FIXED: Image Memory manipulation calculations to be more accurate (should now catch large images more frequently)
- FIXED: Overlays disappearing when creating a file or folder in the file manager failed
- FIXED: Module Designer not letting you delete fields from a form
- FIXED: Publishing drafts not working.
- FIXED: Missing retina icons for thumbnail / delete in the crops editor.
- FIXED: Thumbnails and Crops attempting to be processed even if they were left blank.
- FIXED: Checkbox bug in the installer and adjusted a few other things
- FIXED: Unarchiving second level children
- FIXED: replaceInternalPageLinks converting 0 or another falsey value to "" (thanks tamtt)
- FIXED: Keyboard arrow usage in Firefox on custom select fields
- FIXED: Daily Digest / Password Reset email issues in GMail and Outlook
- FIXED: Front End Editor not showing up if for some reason iframes are display: something-other-than-block in the user CSS
- FIXED: asp/aspx files being allowed as user uploads

### 4.0.3 Release
- ADDED: Better support for installation on Windows with IIS
- FIXED: Another PHP 5.2 compatibility issue in func_get_args
- FIXED: Writable directory errors on Windows environments (should now better determine if a directory is writable)
- FIXED: Static caching not working properly on routed template pages
- FIXED: Reduced memory usage for cached pages
- FIXED: Pages where POST vars were present being cached
- FIXED: Disabled resources still being clickable in the File Manager
- FIXED: Module Designer not properly creating columns in the table.
- FIXED: Packager not properly recognizing the option to include data when exporting a table.
- CHANGED: Resources (File Manager) permissions should now behave the same as Pages permissions in that you can have permission to a sub folder of a folder that you don't have permission to access (the folders you don't have permission to just appear empty and unwritable)
- REMOVED: Settings encryption key as an option in the installer, it's now randomly generated and can be manually editing the config.

### 4.0.2 Release
- FIXED: BigTree::globalizeArray (and its related methods) no longer will overwrite BigTree's globals ($admin, $bigtree, $cms) and should no longer break if the passed in array contains previously used internal variable names to the method ("array", "key", "val", "functions", "func").
- FIXED: BigTree::putFile failing if the root filesystem directory was not readable.
- FIXED: Pending Changes page crashing if no view was present for a pending module change.
- FIXED: Random hits to /pages/update/ causing blank drafts to the homepage.
- FIXED: Admin bar showing up on different sites you're not logged into on the same domain (i.e. logged into /test/admin/ and not /test2/admin/).
- FIXED: Autocomplete should now be off for password fields when editing a user.
- FIXED: Settings icon randomly disappearing from templates editor when zoomed in on Safari/Chrome.
- FIXED: Many to Many and Geocoding buttons not working on initial module form creation.
- FIXED: When creating a callout, BigTree will now verify that the ID isn't in use by another callout.
- FIXED: Some error messages not showing up properly after submitting a form.
- FIXED: Field Types not including their related files when creating packages.
- REMOVED: Google Analytics check from Site Status (new usage of Google Tag Manager prevents us from really knowing anyway).
- UPDATED: Advanced .htaccess now includes a few more mime types that Apache occasionally gets confused (ogv, mp4, webm).

### 4.0.1 Release
- FIXED: IE prior to 10 having issues with background-gradient declarations that use rgba (using "CSS3" parser feature in BigTree)
- FIXED: Issues with forms that contained multiple many to many fields.
- FIXED: An issue where sometimes custom radio buttons in the admin would become duplicated.
- FIXED: Advanced Search in the admin not searching callout content.
- FIXED: BigTree's background-gradient parser when notices were turned on corrupting the end color.
- FIXED: icon_export class in the admin using the same icon as icon_archive.
- FIXED: Sorting of image views (you no longer have the option to choose a sort since it never worked).
- FIXED: Sorting of views by ID should now properly sort numerically instead of alphabetically.
- FIXED: An issue that occurred when a module had multiple forms and an error occurred in a form. The "Return & Edit" button should now return to the proper form.
- FIXED: Mobile and Tablet responsive states of the example site.
- FIXED: A rare issue that could occur where a fatal error would be thrown when editing a user if there was data corruption.
- FIXED: Usernames with a single quote in them would sometimes corrupt with BigTree bar on the front end.
- FIXED: Issues with numeric columns not sorting properly and database populated lists not sorting properly in sortable views.
- FIXED: Incorrect styles for pagination in message center.
- FIXED: Site Integrity Check running on archived pages.
- FIXED: Analytics columns getting list bullets and bad line height.
- FIXED: BigTree::globalizeGETVars / BigTree::globalizePOSTVars not working in PHP 5.2
- FIXED: Incrementing of 404 hits not working when a 301 existed.
- FIXED: Encrypted settings showing their existing value when editing them.
- FIXED: Settings not having internal page links encoded and crops/errors not working properly.
- FIXED: BigTree::putFile not working at all.
- FIXED: Routed templates not working for the homepage.
- FIXED: Module Designer failing to create table columns for column names that were reserved MySQL keywords.
- FIXED: Example Site allowing for empty author fields in blog posts.
- FIXED: Rejecting changes in Pending Changes not clearing view caches (which left the change appearing in views).
- FIXED: $bigtree["current_page"] not existing while processing field types during a page update.
- FIXED: Many to Many and Tags changes not being applied when approving a change in the Pending Changes section.
- ADDED: SVG content-type headers to fix serving svg files in htaccess
- UPDATED: Newer version of CSSMin class.
- CHANGED: Draggable views with search results should now order by the first column instead of their "position" for easier browseability.
- CHANGED: Many to Many fields in forms now have more obscure form keys to make key collisions less likely.
- REMOVED: Deprecated Twitter API class from the example site.

### 4.0 Release
- ADDED: Multiple Service APIs (Twitter, Instagram, YouTube, Google+, Flickr, Disqus)
- ADDED: Multiple Geocoding options (Yahoo, Yahoo BOSS, Google, MapQuest, Bing)
- ADDED: BigTreeModule::getRecent, BigTreeModule::getRecentFeatured, and BigTreeModule::getNonArchived
- ADDED: A heads up view on the dashboard of the logged in user's changes that are awaiting publish
- ADDED: BigTreeAdmin::getPendingChanges (see note in "UPDATED" about the previous method by this name)
- ADDED: Front End admin bar now throws "openbigtreebar" and "closebigtreebar" events
- ADDED: BigTree::relativeTime (gives you a "5 days ago", "1 month ago", etc response like a Twitter timestamp)
- ADDED: Events "addedItem" and "removedItem" are now triggerd by Many to Many
- ADDED: Photo Galleries can now have captions disabled
- ADDED: NavPosition property to BigTreeModule that allows module navigation to go below or above page based navigation
- ADDED: Database Cache support via bigtree_caches (BigTreeCMS::cacheGet and BigTreeCMS::cachePut)
- ADDED: Instruction block to files created when making a new custom field type
- ADDED: BigTree::sendEmail utility function. Utilizes bundled htmlMimeMail class.
- ADDED: "change" events for BigTreeCheckbox and BigTreeRadioButton
- ADDED: Ability to choose a sorting field for "Images" and "Grouped Images" view types
- ADDED: The a few options to BigTreeModule::search
- ADDED: The ability to re-order module view actions and edit custom module view actions.
- ADDED: PayPal REST API payment gateway (beta support)
- UPDATED: BigTreeModule::delete can now accept a full item OR the item's ID
- UPDATED: Some language throughout the admin has been updated to be more clear
- UPDATED: BigTreeAdmin::getPendingChanges is now BigTreeAdmin::getPublishableChanges
- UPDATED: Sorting columns in a searchable view is now always case insensitive in new installs
- UPDATED: Paging ellipsis now goes to the first or last page
- UPDATED: Charset in auto-generated sitemap.xml
- UPDATED: TinyMCE's default allowed elements now include figure and figcaption
- UPDATED: Many to Many now removes items from the available list as they are used and re-adds them as they are deleted
- UPDATED: jQuery to 1.10.2
- UPDATED: jCrop to 0.9.12
- UPDATED: Executable files are no longer uploadable through BigTreeStorage service (previously BigTreeUploadService) to prevent security issues
- UPDATED: Feeds editor now uses the more stylish field adder inspired by Phil P (previously only in Module Forms)
- UPDATED: Example site modules now have icons
- UPDATED: Photo Gallery no longer requires the user to manually hit Add Photo
- UPDATED: Clicking a label next to a radio button now works as if you clicked on the radio button itself
- UPDATED: BigTreeCMS::getBreadcrumbByPage now sets the BreadcrumbTrunk property when a trunk is hit
- UPDATED: Photo Gallery field type can now be used in Callouts
- UPDATED: Example site now includes a breadcrumb.
- UPDATED: Default TinyMCE buttons now include indentation buttons
- UPDATED: Group and form titles added to integrity check naming to make it more clear where the error is (since multiple forms can be in one module and modules can have the same name in different groups).
- UPDATED: Added the ability to not view cache items in add/update/save in BigTreeModule (speeds up entry when importing).
- UPDATED: Module Groups are now alphabetical when choosing a group in the Module add/edit screen
- UPDATED: BigTree's CSS3 Vendor Prefixing now supports transform
- CHANGED: $state_list, $country_list, and $month_list globals are now BigTree::$StateList, BigTree::$CountryList, BigTree::$MonthList
- CHANGED: Significantly improved Amazon S3 cloud storage - now only uses a single bucket with "virtual" directories and authenticates you when you first enter credentials instead of trusting they are correct and also creates a bucket automatically if none is specified.
- CHANGED: BigTree now creates tables with utf8_general_ci collation instead of utf8_bin
- CHANGED: Most JavaScript variables are now namespaced to prevent collisions with custom scripts
- CHANGED: Massive update to the way field types are drawn and processed. All the data you need is now available in the $field variable and fieldsets and labels are automatically drawn. $field["output"] is now used for the process file to return the value instead of $value.
- CHANGED: Removed "Custom Function" field type as it was a precursor to custom field types.
- CHANGED: Many previously global PHP variables are now stored within the $bigtree global array.
- CHANGED: Textarea no longer acts as an unescaped HTML dump. It is now htmlspecialchar'd just like a single line text field. This was confusing and unexplained behavior when compared to a regular text field. Create a custom field type if the old behavior is needed.
- CHANGED: When processing data in form field types, $bigtree["entry"] now contains the current data set (be it the module's row or pages resources or callouts resources)
- CHANGED: When cropping, the default crop should now be ~90% of the size of the uploaded image instead of the minimum required crop
- CHANGED: Admin navigation array is no longer included in _header.php -- it's now in _nav-tree.php so that it's easier to override in custom without changing the whole header
- CHANGED: PayPal Express checkout methods in BigTreePaymentGateway
- CHANGED: Many places in the admin that previously relied on eval() now use call_user_func. eval() remains only for parsers on form fields and post-install package code.
- CHANGED: Made the checking of uniqueness an option in BigTreeModule::add
- CHANGED: Module View Actions are now much smaller and no longer draw their title in the column (more space is now available for data columns)
- CHANGED: Moved BigTreeForms functionality into BigTreeAutoModules, BigTreeForms class no longer exists.
- CHANGED: BigTreeUploadService is now BigTreeStorage and the "upload" method is now "store" (backwards compatibility still exists for the old class name/method)
- CHANGED: "List" field type no longer htmlspecialchars the submitted values.
- CHANGED: BigTree::globalizeArray and related globalize functions now iterate through arrays instead of ignoring them. You can also now pass in functions as string parameters instead of a single array of functions.
- FIXED: Admin header now pulls protocol-agnostic version of html5.js for IE (works for HTTPS admins now)
- FIXED: Paging functions globally use 1 as the first page now instead of 0
- FIXED: Pending items not being editable
- FIXED: Sortable many-to-many fields
- FIXED: Lots of CSS and layout issues
- FIXED: Quick Search / Advanced Search returning pages/modules that the logged in user did not have access to
- FIXED: Settings not handling file uploads, crops, and errors
- FIXED: sqlescape() causing errors on boolean values
- FIXED: cron.php in shared core setups
- FIXED: Non-administrative users not being able to use Save & Preview in Pages
- FIXED: Non-images being dumped into /files/ instead of /files/resources/ when using the File Manager
- FIXED: Pending Pages getting the title "Home" in Pending Changes and having the wrong preview link
- FIXED: Save & Preview button not working on pending pages
- FIXED: Front End BigTree Bar not working on pending pages
- FIXED: Routing issues when a piece of the path was also a piece of one of the commands (i.e. events/new-events/ would fail to route) and a related issue with route history 301s failing when there were similar routes.
- FIXED: Sorting of getNavByParent when requesting hidden nav as well.
- FIXED: Geocoding fields appearing on edit of a module.
- FIXED: 404s potentially hard-cacheing
- FIXED: 404 manager filling with blank URLs when HTML tags were entered in the URL string
- FIXED: Arrays being butchered when passed into a Callout resource
- FIXED: Sorting of columns in searchable views
- FIXED: HTML areas not fitting properly in callout windows
- FIXED: Dual 404/301 headers being sent when a 301 is found in the 404 Manager
- FIXED: Installer not working if deprecated MySQL PHP module isn't available
- FIXED: Settings not having their links encoded properly for dev->live
- FIXED: Issues with Daily Digest / Password Request emails not working properly in some email clients
- FIXED: Page Preview not working if the new template being used has a different type (basic/routed) than the previous template
- FIXED: Date Time and Custom Field Types causing Module Designer to fail
- FIXED: Crash that would occur if you for some reason switched back to the blank spot in a table selector for adding a view/form/feed.
- FIXED: DB populated lists causing the page to crash if the table was renamed/deleted.
- FIXED: Example Site's features form uploading to /files/features/ instead of /images/features/
- FIXED: Example Site's blog search throwing an Exception
- FIXED: Example Site's pagination numbers in Blog and lack of 404s
- FIXED: Example Site's posts module not having tags enabled
- FIXED: Radio buttons having to be clicked twice after being clicked once
- FIXED: Trigger handling on checkboxes so that the "click" events now get the proper "checked" status of the checkbox
- FIXED: max_input_vars being hit when submittion permissions for Users in sites with > ~1000 pages.
- FIXED: Module Designer creating MyISAM tables instead of InnoDB
- FIXED: An issue in pages when you switched templates between two wysiwygs of the same name/type would cause the content to not save
- FIXED: Custom routing issues in the admin
- FIXED: A bug where if a custom field type stored itself as a JSON encoded array and the callout was never edited the next time the page was that field would lose its information
- FIXED: Hitting back after cropping an image would lead to a broken crop page
- FIXED: Admin crashing if an image was too large to do image cropping/thumbnailing on within scope of available memory (now properly throws errors instead of blank screening)
- FIXED: BigTree::createCrop and BigTree::createThumbnail now fail gracefully if there isn't enough memory available
- FIXED: Drag/drop sorting of modules
- FIXED: Double htmlspecialchar encoding of growl messages
- FIXED: Removed some console.log's that were left in Javascript
- FIXED: An issue with external link checking in Integrity Check
- FIXED: An error message is now shown if a form submission exceeds PHP's post_max_size setting (instead of causing blank entries / bad saves to occur)
- FIXED: A bug where float parsing would return NULL for empty values even if NULL wasn't allowed
- FIXED: BigTreeAutoModule::createItem not accepting arrays as values
- FIXED: Module Forms/Views not deleting properly
- FIXED: A module class' getBreadcrumb and getNav being called even if the methods don't exist.
- FIXED: Data not transitioning between callout types
- FIXED: Date & Time pickers not showing up in callout resources
- FIXED: Pages not locking properly when another user was editing them
- FIXED: Possible infinite loop when generating a route
- FIXED: Array of Items field type doing odd things if the developer never adds fields to it
- FIXED: Array of Items HTML field sometimes failing
- FIXED: Many to Many not showing up when there was nothing to tag
- FIXED: Missing ability to add form field types to packages
- FIXED: Callout resources asking to be the SEO body copy / H1 score
- FIXED: Poor namespacing of headers/footers in ajax and routed templates that could possibly be junked by the proceeding includes
- FIXED: Lack of error messages when a file upload failed in the File Manager
- FIXED: Form fields sticking around after the column is removed from a table
- FIXED: Updating a module view/form should now update its related action name
- FIXED: The super large size of the TinyMCE icon set (should be PNGcrushed now)
- FIXED: Editors not being able to delete their own pending entries
- FIXED: Behavior of BigTreeSelect when removing elements and when all elements are removed
- FIXED: Behavior of BigTreeManyToMany when the add button is clicked with nothing left to add
- FIXED: BigTreeSelect now gets wider when a larger option is added
- FIXED: Publishing pending entries did not handle arrays properly
- FIXED: depth > 1 parsing in BigTreeAdmin::getNaturalNavByParent — thanks to asiral on the forums.
- FIXED: Selected file / pane not resetting when you begin to search in the File Browser — thanks asiral on the forums.
- FIXED: Non-developers seeing a checked checkbox when adding top level navigation even though they would end up getting hidden nav.
- FIXED: Encrypted system settings still untranslating.
- FIXED: Sub-routes with similar route partials getting stuck in the admin breadcrumb
- FIXED: BigTreeSelect drop downs not closing on scroll inside of callout editor windows.
- FIXED: Lots of issues with WebKit, overflow scroll windows, and the BigTreeSelect boxes.
- FIXED: Double calls to BigTreeCustomControls() causing already styled items to bug out
- FIXED: Some XSS vulnerabilities. Thanks to Contra on github for pointing them out.
- FIXED: getSitemapXML failing if a custom page module didn't implement getSitemap.
- FIXED: Front End Editor not including custom admin CSS/JS
- FIXED: BigTree bar not being loading over https when on an https page.
- FIXED: SQL injection possibility when inserting a ' into a URL
- FIXED: An issue related to # in internal page links
- FIXED: Updating resource titles in File Manager. Thanks to asiral on the forums.
- FIXED: A potential cross-site scripting issue on the module view add page. Thanks to High-Tech Bridge Security Research Lab for alerting us of this.
- FIXED: A Cross-Site Request Forgery exploit that would allow logged-in BigTree admins hitting a malicious page to automatically create / update users. Thanks to High-Tech Bridge Security Research Lab for alerting us of this.
- FIXED: Issues with MultiViews in Apache causing asfg.sdgsd in /site/ to tank the /asfg/ route in BigTree. Thanks @mcongrove
- FIXED: Searching quick links and through the main search in the admin should no longer return archived pages.
- FIXED: Fixed BigTreeDialog close icon when there are no buttons.
- FIXED: Payment gateways not showing info when you go back into them after setting your API keys.
- FIXED: Improper latin encodings on some columns in BigTree tables
- FIXED: Memory leak in BigTreeCMS::replaceInternalPageLinks
- FIXED: User profile not being editable by normal users. Thanks spud!
- FIXED: Checkboxes and radio buttons misbehaving in callouts.
- FIXED: Custom Field Types not showing up in Settings
- FIXED: Pending Entries not showing up properly in Images/Grouped Images views.
- FIXED: Double cache when using BigTreeModule::save
- FIXED: Internal page links showing up as ipl:// in Settings list
- FIXED: Potential crazy database corruption if you set your config's www_root or static_root to "/"
- FIXED: Password resets and logging out when config's force_secure_login is set and config's admin_root isn't https.
- FIXED: Styling module views showing a number instead of action title for custom actions.
- FIXED: Double htmlspecialchars encoding of callout names in the callout selector drop down.
- FIXED: HTML areas drawing non-htmlspecialchared data into a <textarea> block. Thanks asiral for the bug report.
- FIXED: Stopped date fields from drawing crazy stuff if 0000-00-00 gets entered in.
- FIXED: BigTreeAutoModules::publishPendingItem inserting improper data into the database for NULLs and such.
- FIXED: Sort direction not working for the default sorted column in searchable views.
- FIXED: Generally sorted out issues with sorting of columns that are originally numeric but run parsers or have foreign keys that indicate they're probably a string.
- FIXED: Various IE 7/8/9/10 issues.
- FIXED: Editing a feed should now properly show the list of unused fields.
- FIXED: Various issues with the Payment Gateway overview screen and sub sections throwing warnings.
- FIXED: Updating a module to have group based permissions (or changing those) not clearing the module's view cache.
- FIXED: Replying to a message that you sent trying to send the message to you instead of all the people you'd previously sent the message to.
- FIXED: BigTree::trimLength using a literal UTF-8 ellipsis character. Now uses an HTML entity for better cross-character-set support.
- FIXED: Issues when a BigTreeSelect was disabled and re-enabled it behaved poorly.
- FIXED: BigTree Bar breaking when a user's name contained an apostrophe.
- FIXED: View Options breaking if they were edited before choosing a table.
- FIXED: Vitals & Statistics showing for non-administrators.
- FIXED: Messages not being properly recognized as read when the user was not the first person to read them.
- FIXED: Values for "List" field type not being htmlspecialchar'd when drawing the list
- FIXED: Non-htmlspecialchar'd data getting into the view cache.

- REMOVED: "Menu" field type, as it was just a pre-configured Array of Items
- REMOVED: BigTreeCMS::getCallout -- replaced with improved version of BigTreeAdmin::getCallout
- REMOVED: When there are errors in your form submission, the Delete button no longer shows up.
- REMOVED: Twitter callout from example site (so long Twitter API 1.0)

### 4.0RC2
- ADDED: 404 Report now has paging and delete functionality.
- ADDED: Foreign key constraints to tables.
- ADDED: Module Views now pass their state information to forms so that when you return from the form you are where you left off.
- ADDED: Site Integrity Check now also checks module content.
- ADDED: More icons to choose from for module actions.
- ADDED: SQL queries are now logged to $bigtree["sql"]["queries"] when debug mode is on.
- ADDED: Support for module actions that contain /s in them so they can pretend to be in a subdirectory of custom modules.
- ADDED: Module Actions add/edit can now specify a form / view.
- ADDED: Placeholder image functionality.
- ADDED: BigTree::geocodeAddress
- ADDED: The ability to package instructions and post-install PHP code when importing a package.
- ADDED: You can now turn on/off tagging in modules and pages.
- ADDED: Delete All function for 404s without redirects entered.
- ADDED: Page titles should now reflect better where you are in the admin.
- ADDED: New, prettier email templates for daily digest / forgot password.
- ADDED: Searching in a grouped view now includes items in a group where the group name matches your query.
- ADDED: $bigtree["page"]["link"] now contains the equivalent of $cms->getLink($bigtree["page"]["id"]);
- ADDED: Default configuration variables to show a Development Area flag with a link to the website.
- ADDED: Default configuration variables to preload the admin with JS and CSS ($bigtree["config"]["admin_css"] and $bigtree["config"]["admin_js"] arrays)
- UPDATED: Consolidated a lot of images into a single sprite for faster loading of the admin.
- UPDATED: New glyph-based icon set and 2x image set for retina-capable displays.
- UPDATED: Google Analytics was completely revamped since RC1's authentication feeds were deprecated.
- UPDATED: Newer versions of TinyMCE and related plugins.
- UPDATED: The example site is updated to support "callouts" on the homepage for extensibility and also has had its code cleaned up.
- UPDATED: LESS compiler to support @import
- UPDATED: Credits page to be more comprehensive - linked it up in the footer.
- UPDATED: Example site blog now supports previewing.
- UPDATED: Adding a Geocoding or Many to Many to a form now automatically brings up the settings dialog.
- FIXED: BigTreeAutoModule's getViewForTable should be static.
- FIXED: "route" being limited to 30 characters in bigtree_pages.
- FIXED: View Columns should no longer break if they were styled and a Preview button was added.
- FIXED: Parameters for BigTreeCMS's getBreadcrumb function were wrong.
- FIXED: BigTree admin's login page should now load resources over HTTPS if force_secure_login is set in the config.
- FIXED: Documentation bugs
- FIXED: File Extensions not being set in the database correctly for things uploaded to the File Manager.
- FIXED: Issue with hidden resources in Callouts.
- FIXED: Users section should now have sortable columns and paging should now work properly.
- FIXED: Permission issue with drag and drop.
- FIXED: A bug with Array of Items in Chrome.
- FIXED: Site Status crashing if PHP was running as CGI.
- FIXED: Several Module import/export issues.
- FIXED: Date/Time picker styles in WebKit browsers.
- FIXED: Thumbnail images in dialog pop-ups.
- FIXED: Misbehavior of the Field Selector for Module Forms.
- FIXED: Unintended creation of orphaned temporary images.
- FIXED: Views crashing if all the columns were removed.
- FIXED: Inclusion of hidden files in /custom/inc/required/
- FIXED: Poor english in some places.
- FIXED: CSS and JavaScript not getting Last-Modified headers causing redownloads each time.
- FIXED: Administrators not being able to archive top level hidden pages.
- FIXED: Random CSS/JS cache files being created. Only combinations set in the config will create them now.
- FIXED: Missing "default to now" option for Date & Time picker.
- FIXED: Date & Time picker showing a default date of 1969.
- FIXED: Missing "Required" option for Date/Time/Date & Time pickers.
- FIXED: Custom view actions not being able to be disabled after added.
- FIXED: Content Alert inheritance buttons in user editor.
- FIXED: Double encoding of html special characters in module views.
- FIXED: Odd encoding issue on pre/post process module form functions.
- FIXED: Site Status now properly checks all directories for writability.
- FIXED: Some BigTreeForms methods being public instead of static.
- FIXED: Sorting in grouped image views.
- FIXED: BigTreeAdmin::deleteFieldType now properly removes the options file.
- FIXED: A bug in BigTree::trimLength
- FIXED: Improper headers being sent for images served through TinyMCE's javascript folder.
- FIXED: A bug with the view cache and pending entries.
- FIXED: Many to Many bugging out if there were no possible relationships to be made.
- FIXED: Fields not being validated when creating a form / action / view.
- FIXED: Settings not translating properly.
- FIXED: Not being able to preview an expired or publish-in-the-future page.
- FIXED: Save & Preview not working in Pages when there were crops.
- FIXED: Front end cropping not closing the window properly.
- FIXED: Breadcrumb breaking in Pages if trunk was set.
- FIXED: Int fields that were empty and didn't accept NULL being butchered.
- FIXED: Forgot Password email coming from @bigtreecms.com
- FIXED: Group sorting when it was sorting by numeric values.
- FIXED: Page revisions never falling off after 10 / more than a month old.
- FIXED: BigTreeSelect not recognizing when a <select> was disabled.
- FIXED: Numeric commands not being passed to module actions.
- FIXED: Various issues related to pending changes.
- FIXED: Grouped view items where the item's group is missing.
- FIXED: Template creation no longer creates a "Resources Available" comment if none are available.
- FIXED: Columns named "route" should now be assumed as the Generated Route field type.
- FIXED: BigTree::copyFile so that it supports URLs for the source.
- FIXED: An issue with module forms doubling when exporting a module.
- FIXED: An issue where adding a new resource to a callout wouldn't let you save it's radio button value.
- FIXED: A text overflow issue on view columns.
- FIXED: BigTreeModule::search method.
- FIXED: BigTreeCMS::getLink now recognizes if you're requesting the current page's link and doesn't ask the database for it.
- FIXED: Amazon S3 storage settings not sticking properly.
- FIXED: Caching of unpublished view items.
- FIXED: BigTreeAdmin::autoIPL issue with URLs where text followed.
- FIXED: Lots of issues with tables where column names contained spaces or `
- FIXED: Column sorting in searchable views.
- FIXED: Problems caused by the column set to sort by wasn't included in the view.
- FIXED: IE10 background gradient support.
- FIXED: Failed photo uploads causing the field to be filled with the value of the previous field.
- FIXED: View paging not making sense if there were more than ~5 pages.
- FIXED: Admin crashing if the table for a form/view was deleted when trying to edit them.
- FIXED: Crashes in database populated lists when the table it pulled from was deleted.
- FIXED: Front end editor should no longer show Edit if the user doesn't have access to edit the page.
- FIXED: Editing a page should now return you to the page you were previously on instead of always its parent.
- FIXED: Quick Search is now more clear about the existence of Advanced Search.
- FIXED: Previewing the homepage.
- FIXED: Issues where a person with different group based permissions on a single module could escalate their editor/publisher rights.
- FIXED: Improper calculation of quarterly reporting for Google Analytics.
- FIXED: Issues with Analytics crashing the cron update so that it never sends Daily Digest email updates.
- FIXED: Demo site should now properly respect publish dates on blog entries.
- FIXED: Double encoding of relationships in Many to Many fields.
- FIXED: Adding Geocoding to forms.
- FIXED: Images not showing up in advanced search.
- FIXED: Preview/Save & Preview when editing from a link on the front end of the site.
- FIXED: Generated Route field type did not work if the column's name was something other than "route"
- FIXED: Not being able to save & preview the homepage.
- CHANGED: Page Header and Page Content are no longer required fields in the example site's Content template.
- CHANGED: Simple HTML WYSIWYG no longer has the Code option.
- CHANGED: Passing of information in Developer section from using commands to GET to be more clear.
- CHANGED: Admin area now uses $_SESSION["bigtree_admin"] instead of $_SESSION["bigtree"] to avoid register_globals breaking front ends.
- CHANGED: BigTree now defaults to MySQLi instead of MySQL.
- CHANGED: BigTree now uses sqlescape() instead of mysql_real_escape_string so that it can cooperate with MySQLi and MySQL.
- CHANGED: Improved the layout of Site Integrity Check
- CHANGED: Crops will now be a square if only one dimension was entered.
- CHANGED: Display of editing a Setting.
- CHANGED: If a class is not found when auto loading, it will clear the module class list cache file in case it's out of date.
- CHANGED: sqlfetch() calls will no longer throw an exception if you don't have debug on.
- CHANGED: Tagging now associates by table instead of module.
- CHANGED: SQL commands are now in /core/inc/bigtree/sql.php, moved most of /core/inc/utils/ into /core/inc/lib/ to be more accurate in the naming.
- CHANGED: Installer now uses the main admin's css/js instead of a custom subset.
- CHANGED: Several items that were always included in bootstrap are now auto loaded when needed.
- CHANGED: Consolidated code for replacing relative/hard roots.
- CHANGED: Approving a change now growls the proper module name.
- CHANGED: If an error is thrown in Pages, the tab is now switched to the first tab that contains an error.
- CHANGED: Routing now supports unlimited depth levels of _header and _footer and routing code has been consolidated and optimized.
- CHANGED: Many to Many's list parser function now parses both the list of available relationships as well as the list of existing relationships.
- CHANGED: BigTreeModule::search is now case insensitive by default.
- CHANGED: New default layout for the admin includes H1s, breadcrumb, and navigation for modules. THIS MAY CAUSE BACKWARDS COMPATIBILITY ISSUES WITH CUSTOM MODULES THAT DRAW IT ON THEIR OWN.
- CHANGED: Including custom CSS and JavaScript in the admin is now done through $bigtree["css"] and $bigtree["js"] instead of $css and $js — THIS IS A BACKWARDS COMPATIBILITY BREAK FOR CUSTOM MODULES.
- CHANGED: form_container class name is now container - THIS IS A BACKWARDS COMPATIBILITY BREAK FOR CUSTOM MODULES. 
- CHANGED: Cropping code is now consolidated across modules/pages.
- CHANGED: Pages tab should no longer be in the header if a user has no pages access.
- CHANGED: BigTreeBar javascript is now namespaced better in a JavaScript object.
- CHANGED: Users with Group Based publisher permission can now publish their entry if they choose a group they have publish access to without first saving it.
- CHANGED: Switching a select that affects the group based permissions of an entry now changes the button actions at the bottom of the form.
- CHANGED: The permissions tree in the User editor should auto-expand down to where specific permissions have been set.
- CHANGED: Page Paradigm now more semantic. Calls to paged methods now start at 1 for the first page instead of 0. — THIS IS A BACKWARDS COMPATIBILITY BREAK FOR BigTreeModule::getPage
- REMOVED: Dropdown of modules from the main header.
- REMOVED: getPendingPage and getTagsForPage from BigTreeAdmin since they were redundant with BigTreeCMS's implmentation.

### 4.0RC1
- NEW: Retina Display asset support (create 2x images at lower quality when capable)
- NEW: Forms can now manually specify a return view.
- NEW: Image quality settings can now be set in /templates/config.php for both retina images and regular images (previously BigTree always used 90%).
- NEW: Crops and thumbnails can now be given grayscale treatment.
- UPDATED: Custom <select>s now support <optgroup>
- UPDATED: Thumbnails of cropped images now re-crop from the original image to preserve quality.
- UPDATED: Template add/edit now groups Related Modules in <optgroups> for easier choosing of modules with the same name.
- FIXED: Form's action routes not updating if suffix changed.
- FIXED: Searchable view sorting.
- FIXED: Template creation now throws an error message if you try to use an existing ID.
- FIXED: # being thrown if you click on an already active tab in Pages. Now scrolls to the top.
- FIXED: Regular user permissions that totally got screwed in beta 7.
- FIXED: Trunk support in BigTreeCMS::getToplevelNavigationIdByPage
- FIXED: Duplicate entries sometimes occurring in sitemap.xml
- FIXED: Warning being thrown for output filters being false in router.
- FIXED: Terminology on Callout add/edit page. Fixed options button being in the wrong place as well. Fixed doubled radio buttons.
- FIXED: Group based permissions being checked off for modules where it was null.
- FIXED: Options button in Module Designer.
- FIXED: Image Views ignoring the "Edit" function being deactivated.
- FIXED: Admin not redirecting to the requested page if it was requested when you weren't logged in. (Now returns to the requested page after login).
- FIXED: Dialogs not re-centering if their height changed.
- FIXED: Template tab in Pages now hides if a user doesn't have access to the template that is currently set (i.e. the template is Administrator or Developer only).
- FIXED: Auto Modules now properly refresh their locks on content every minute.
- FIXED: Double encoding of the names of Field Types (leading to &amp; showing up).
- FIXED: Missing image when adding an image to a photo gallery for the first time.
- FIXED: Packaging a module with tables that had foreign keys not being packaged in the proper order (leading to failed creation of tables due to foreign key constraints).
- RETURNED: Support for /sitemap/ defaulting to /templates/basic/_sitemap.php
- REMOVED: Imagick support. GD support remains.

### 4.0b7
- NEW: Redesigned sample site that provides more in depth examples of using BigTree
- NEW: Field Types are now able to be used in Settings
- NEW: Gravatar support for users
- NEW: Date Time Picker support
- NEW: BigTree::describeTable method for a faster way to get SQL table columns
- NEW: Foreign key constraints are now recognized when creating a form and are automatically created to be database populated lists.
- NEW: ENUM columns are now recognized when creating a form and are automatically created to be static lists.
- NEW: BigTreeModule::getSitemap method to allow for drawing sitemap branches from a module class.
- UPDATED: LESS Compiler to 0.3.5
- UPDATED: Authentication no longer caches permissions via sessions.
- UPDATED: New installs now set SERVER_ROOT in /site/index.php to allow for sym-linked /core/ folders.
- UPDATED: Install.php can now accept command line options instead of $_POST vars for automated installs.
- UPDATED: New installs will receive indexes and foreign key constraints on bigtree core tables.
- UPDATED: Retina assets for custom controls.
- UPDATED: CSS parsing to include root variable auto replacing (www_root/ admin_root/ static_root/ etc).
- FIXED: Custom select boxes now blur other select boxes when clicked.
- FIXED: Custom select boxes now scroll the window down to show their full drop down when low on the page.
- FIXED: A bug with SEO scoring unique titles improperly.
- FIXED: Turning on notices when debugging a custom module shouldn't break the whole admin now.
- FIXED: Bug related to locked pages/entries.
- FIXED: Searching users, settings, and resources is no longer case sensitive
- FIXED: Missing jump dropdown in Dashboard areas.
- FIXED: Searching auto modules is no longer case sensitive
- FIXED: Missing "custom" fields in view options, field options, other dialogs
- FIXED: Default templates using $content instead of $bigtree["content"]
- FIXED: Google Analytics setup failing to store encrypted information properly in the database.
- FIXED: Dialogs now stay centered on the screen when the browser resizes.
- FIXED: Bug that caused image resources to use {wwwroot} over {staticroot}
- FIXED: Empty module groups are no longer shown in the Modules dropdown
- FIXED: File Browser "Cancel" button not closing the window when packaging a module.
- FIXED: The front end editor now alerts a user if there is no editable content.
- FIXED: Custom selects misbehaving in dialogs
- FIXED: Sorting via fields not using backticks (`) around column names
- FIXED: RSS 2 feeds not really being RSS 2.0
- FIXED: Warning that could show when preprocessing functions didn't return an array
- FIXED: A rare bug where creating a new item in a module before the module's view was cached would make the existing items never cache.
- REMOVED: Custom JavaScript and CSS in Auto Module forms.
- REMOVED: Uncached ability in Auto Module views.

### 4.0b6
- NEW: BigTree now allows for usage of index.php routing WITHOUT .htaccess / mod_rewrite
- NEW: BigTree::unzip function (preparing for the future)
- FIXED: Buttons in the image browser not working in beta 5.
- FIXED: Example site "Wonders" form missing in beta 5.
- FIXED: Module forms not creating properly in beta 5.
- FIXED: Choosing image size not working in Image Browser in beta 5.
- FIXED: Styles of the H3 in the image size chooser in the Image Browser.
- FIXED:  404s in the 404 list not being htmlspecialchar'd
- FIXED: Some "Advanced Link" problems in TinyMCE
- FIXED: Views with more than 5 columns causing a critical error.
- FIXED: Many problems that stopped module packaging / importing from working in recent betas.
- FIXED: Callout images throwing an error if they were unchanged from last publish (Thanks Phil P!)
- FIXED: A warning that occurred if you uploaded an invalid image.
- FIXED: Lazy loading of modules throwing a critical error when class_exists() was called (fixes Module Designer!)
- FIXED: Module creation process showing urlencoded titles
- FIXED: Homepage resources loading into a new page if the template was changed (Thanks Phil P!)

### 4.0b5
- NEW: Array of Items now supports using several different field types (text, textarea, date, time, html)
- NEW: BigTree version updater automatically does database and file system changes when a new revision is installed.
- NEW: "Trunk" flag for pages that allows for resetting BigTreeCMS::getTopLevelNav and BigTreeCMS::getBreadcrumbByPage methods.
- UPDATED: TinyMCE to latest version.
- UPDATED: BigTreeAdmin::updateSetting now supports system settings.
- UPDATED: System settings are now consolidated to not clutter the bigtree_settings table so much.
- UPDATED: Cleaned up list-generating code to be usable by third party field types (see BigTreeListMaker JavaScript class).
- UPDATED: Callouts "Title" now renamed "Label" so there aren't two things called "Title".
- UPDATED: Daily Digest email now sends out emails alerting you of unread messages in Message Center.
- UPDATED: Cleaned up the global namespace to move several variables ($content, $layout, $page, $callouts, $resources) into a $bigtree array variable.
- FIXED: A possible notice in install.php
- FIXED: Updating a pending page change (fixes restoring to a revision when a pending change to a page exists)
- FIXED: "Cron" no longer tries to run Google Analytics if a profile isn't set.
- FIXED: The size of some panels in the Image/File browser.
- FIXED: Many to Many editor's odd style issues.
- FIXED: Generated routes failing when publishing a pending item.
- FIXED: Preview URL for the homepage.
- FIXED: Double-encoding of HTML entities for callouts.
- FIXED: Errors for "Array of Items" when used in callouts.
- FIXED: Some issues with inline popups in TinyMCE.
- FIXED: Custom select boxes were firing "changed" instead of "change" like a normal <select> element would.
- FIXED: Tooltips not hiding properly (and causing things behind them to be unclickable)
- FIXED: Creating a user not setting the daily digest flag properly.
- FIXED: "Cron" not getting the right environment variables when running daily digest.
- FIXED: "Growl" messages not showing up in Users section.
- FIXED: Users rows not disappearing after deleting them.
- FIXED: Deleting a user confirmation dialog saying "Resource" instead of "User"
- FIXED: Styling and clickablility of Quick Search results in admin.
- FIXED: File Browser in IE8, removed it's use with a warning in < IE8.
- FIXED: Sub directories are no longer (attempted to be) included in /custom/inc/required/ (thus throwing a warning)
- FIXED: Pages not publishing certain properties properly when published via the Pending Changes section of Dashboard.
- FIXED: Saving a revision not showing the new revision immediately.
- FIXED: Array of Items not getting a draggable placeholder
- FIXED: Daily digest going out even if there was nothing for the user to be notified about.

### 4.0b4
- Fixed issues with saving pending changes on pages that were empty of content.
- Fixed publishing pending changes for pages from the dashboard
- Fixed the number of pending page changes on the dashboard always showing 1.
- Updated the layout of the user permission editor to list modules by group.
- Fixed the module permissions always showing a blue arrow even when sub-permissions were not available.
- Fixed default date format for the date picker if "Default to Today's Date" was set.
- Fixed callout files/images disappearing on re-save
- Fixed resources in callouts saving strangely.
- Fixed callout resources ignoring validation rules.
- Restored ability to add classes to images in TinyMCE
- Added missing + buttons in module designer.
- Removed confirm dialogs from deleting fields from a form.
- Fixed an error that caused options for a view to not save (and throw a warning) on initial creation.
- Fixed cron-job not running properly.
- Fixed BigTreeCMS::makeSecure
- Fixed a few Javascript events in the admin (changing callout types and a few other places were broken in beta 3)
- Switched sorting in the admin to use POST instead of GET (to support thousands of items).

### 4.0b3
- Updated image cropper count design to make the number of crops more obvious
- Updated callouts to allow developers to set a default title.
- Updated module creation so that if there isn't a related table it throws a growl and moves away from the view/form creation process.
- Fixed custom view actions behavior.
- Fixed BigTreeModule::getTagsForItem
- Changed positions to always be position: fixed instead of a mix of fixed and absolute.
- Fixed the variable scope in which _404.php is included on 404 pages.
- Fixed pulling module class' breadcrumb.
- Fixed BigTreeCMS::urlify to properly decode html entities before creating a URL string (prevents this-amp-that type URLs).
- Fixed some z-index issues with dialog windows.
- Fixed Array of Items field type item order to be consistent with List.
- Fixed using view actions (feature, archive, approve, dragging to change position) on items that are not yet published.
- Fixed TinyMCE paste problems.
- Added the ability to specify a required user level for a module action to appear in a module's admin navigation.
- Updated the Home template to default to developer-only and set its position to be second in the list of default templates (so that content is the default for new pages).
- Fixed (Database Populated) List field type not remembering your sort order the first time you create it.
- Fixed Field Types not remembering whether they're allowed for Callouts on initial creation.
- Fixed link to analytics on the dashboard.
- Fixed Feeds not loading properly on the front end.
- Fixed route history not being created when moving pages.
- Fixed CSS border radius in several places in Safari.
- Fixed grouped module breadcrumb going to the wrong place if you clicked the group name.
- Fixed module designer creating the wrong icons and in the wrong order.
- Updated BigTreeAdmin::createModuleAction to allow you to specify a default position.
- Updated view caching to process out {wwwroot}
- Fixed Module View creation to throw proper errors on draggableness (previously checked the wrong properties so false errors were thrown and real ones were missed)
- Added + icons to the edit module screen.
- Silenced some warnings when images had bad EXIF data.
- Made initial content age be the date of installation instead of 1969.
- Fixed install / admin errors when Notices were turned on in PHP.
- Updated the style of the Unused Field adding mechanism to more accurately group the + icon and the field name together.  Thanks philp!
- Fixed the front end editor messing up page titles / nav titles that had & in them.
- Updated sqlfetch() to throw an Exception when you give it a bad sqlquery() result to aid in debugging.
- Added BigTreePaymentGateway -- a way to handle payment gateways without knowing which one the user has.
- Updated the layout of the developer landing to support Payment Gateways.
- Fixed styling of phone / email field types when in callout editor.
- Fixed callout's phone number processing.
- Fixed the initial description of a callout's resources that's written to the callout file.
- Fixed mobile.css and no-zoom/resize being set for mobile browsers (should work now on iPhone/Android, though not optimized for it yet).
- Added placeholder styles for dragging of callouts and image views.
- Fixed image views not using the "prefix" option properly.
- Changed to native event firing on custom Select, Radio, and Checkboxes in the admin (used to be checked:click and select:changed, now you just observe click or changed).
- Fixed Google Analytics and Daily Digest not sending out in the event that your cron isn't running (should have happened on any visit to the admin if cron hasn't run in 24 hours, wasn't)
- Fixed File Browser not working on the front end editor.
- Stopped the home page from being able to be moved.

### 4.0b2
- Removed .htaccess warnings from the installer since it's throwing a lot of warnings when there isn't a problem.
- Fixed page "Revisions" showing the currently published copy as an option for creating a new draft.
- Fixed fatal error that's thrown when an item was locked and someone else tried to access it.
- Updated BigTree::curl to not verify SSL host/peer (caused lots of failed cURLs)
- Fixed a warning thrown when calculating SEO value if some of the field types were arrays in a page template.
- Silenced some warnings in the installer (caused by shared server openbase_dir stuff).
- Fixed styles in the example site.
- Fixed an error that caused issues with grouped views in modules.
- Removed the ability to use Field Wrappers.
- Changed the default sorting for templates.
- Changed the "name" field of resources of callouts to be "title" like everything else (if you've made some callouts, their titles may not be working now, sorry!)
- Fixed some errors in processing photo gallery field types.
- Fixed a bug with file dialogs when hitting Escape to close them.
- Updated the user editor to hide permissions that aren't applicable to Administrators and Developers.
- Fixed text-ellipsis for long URLs in the Properties section of pages.
- Fixing pending changes to pages not decoding properly (caused broken images in HTML areas).
- Added + icons to buttons in forms to bring better attention to them adding things.
- Removed extraneous old code from BigTree 3.3
- Fixed some HTML5 validation errors.
- Fixed a tag closing bug that was causing Internet Explorer to not render the nav properly.
- Fixed a bug with tagging items not sticking.
- Fixed a message when deleting a 404.

### 4.0b1
- Initial public release.
